23. Отладка
==============

### Контрольный список

#### Методики поиска дефектов 

+ Формулируя гипотезу, используйте все имеющиеся данные. 
+ Детализируйте тесты, приводящие к ошибке. 
+ Проверяйте код при помощи блочных тестов. 
+ Используйте разные доступные инструменты. 
+ Воспроизведите ошибку несколькими разными способами. 
+ Генерируйте больше данных для формулирования большего числа гипотез. 
+ Используйте результаты отрицательных тестов. 
+ Используйте «мозговой штурм» для построения нескольких гипотез. 
+ Составьте список подходов, которые следует попробовать. 
+ Сократите подозрительную область кода. 
+ С подозрением относитесь к классам и методам, которые содержали дефекты ранее. 
+ Проверьте код, который был изменен недавно. 
+ Расширьте подозрительный фрагмент кода. 
+ Выполняйте интеграцию инкрементно. 
+ Проверяйте наличие распространенных дефектов. 
+ Обсудите проблему с кем-то другим. 
+ Отдохните от проблемы. 
+ Установите сроки быстрой и грязной отладки. 
+ Составьте список методик грубой силы и используйте их. 

#### Методики поиска и исправления синтаксических ошибок 

+ Не полагайтесь на номера строк в сообщениях компилятора. 
+ Не доверяйте сообщениям компилятора. 
+ Не доверяйте второму сообщению компилятора. 
+ Разделяй и властвуй. 
+ Используйте редактор с проверкой синтаксиса для поиска неверно размещенных символов комментария и кавычек. 

#### Методики устранения дефектов 

+ Прежде чем браться за решение проблемы, поймите ее. 
+ Не ограничивайтесь пониманием проблемы — поймите программу. 
+ Подтвердите диагноз проблемы. 
+ Расслабьтесь. 
+ Сохраняйте первоначальный исходный код. 
+ Устраняйте проблему, а не ее симптомы. 
+ Изменяйте код только при наличии веских оснований. 
+ Вносите в код по одному изменению за раз. 
+ Проверяйте исправления. 
+ Добавляйте в набор тестов блочные тесты, приводящие к проявлению имеющихся дефектов. 
+ Поищите похожие дефекты. 

#### Общий подход к отладке 

+ Рассматриваете ли вы отладку как возможность лучше изучить программу, ошибки, качество кода и подход к решению проблем? 
+ Избегаете ли вы суеверного подхода к отладке, основанного на методе проб и ошибок? 
+ Полагаете ли вы, что ошибки допущены именно вами? 
+ Используете ли вы научный метод для стабилизации несистематических ошибок? 
+ Используете ли вы научный метод для нахождения дефектов? 
+ Используете ли вы несколько методик поиска дефектов? 
+ Проверяете ли вы корректность исправлений? 
+ Анализируете ли вы предупреждения компилятора? Используете ли вы инструменты профилирования выполнения программы, среды тестирования, леса и интерактивные отладчики? 

### Ключевые моменты

+ Отладка  —  это  тот  этап  разработки  программы,  от  которого  зависит  возмож ность ее выпуска. Конечно, лучше всего вообще избегать ошибок, используя другие методики,  описанные  в  этой  книге.  Однако  потратить  время  на  улучшение  на выков  отладки  все  же  стоит,  потому  что  эффективность  отладки,  выполняемой лучшими  и  худшими  программистами,  различается  минимум  в  10  раз.
+ Систематичный  подход  к  поиску  и  исправлению  ошибок  —  непременное  условие  успешности  отладки.  Организуйте  отладку  так,  чтобы  каждый  тест  приближал  вас  к  цели.  Используйте  Научный  Метод  Отладки.
+ Прежде  чем  приступать  к  исправлению  программы,  поймите  суть  проблемы. Случайные предположения о причинах ошибок и случайные исправления только  ухудшат  программу.
+ Установите  в  настройках  компилятора  самый  строгий  уровень  диагностики  и устраняйте причины всех ошибок и предупреждений. Как вы исправите неуловимые  ошибки,  если  будете  игнорировать  явные?
+ Инструменты  отладки  значительно  облегчают  разработку  ПО.  Найдите  их  и используйте,  но  не  забывайте,  что  у  вас  есть  еще  и  голова.