24.3. Виды рефакторинга
==============

### Контрольный список

#### Рефакторинг на уровне данных 

+ Замена магического числа на именованную константу. 
+ Присвоение переменной более ясного или информативного имени. 
+ Встраивание выражения в код. 
+ Замена выражения на вызов метода. 
+ Введение промежуточной переменной. 
+ Преобразование многоцелевой переменной в несколько одноцелевых переменных. 
+ Использование локальной переменной вместо параметра. 
+ Преобразование элементарного типа данных в класс. 
+ Преобразование набора кодов в класс или перечисление. 
+ Преобразование набора кодов в класс, имеющий производные классы. 
+ Преобразование массива в класс. 
+ Инкапсуляция набора. 
+ Замена традиционной записи на класс данных. 

#### Рефакторинг на уровне отдельных операторов 

+ Декомпозиция логического выражения. 
+ Вынесение сложного логического выражения в грамотно названную булеву функцию. 
+ Консолидация фрагментов, повторяющихся в разных частях условного оператора. 
+ Использование оператора break / return вместо управляющей переменной цикла. 
+ Возврат из метода сразу после получения ответа вместо установки возвращаемого значения внутри вложенных операторов if-then-else. 
+ Замена условных операторов (особенно многочисленных блоков case) на вызов полиморфного метода. 
+ Создание и использование «пустых» объектов вместо проверки того, равно ли значение null. 

#### Рефакторинг на уровне отдельных методов 

+ Извлечение метода из другого метода. 
+ Встраивание кода метода. 
+ Преобразование объемного метода в класс. 
+ Замена сложного алгоритма на простой. 
+ Добавление параметра. 
+ Удаление параметра. 
+ Отделение операций запроса данных от операций изменения данных. 
+ Объединение похожих методов при помощи их параметризации. 
+ Разделение метода, поведение которого зависит от полученных параметров. 
+ Передача в метод целого объекта вместо отдельных полей. 
+ Передача в метод отдельных полей вместо целого объекта. 
+ Инкапсуляция нисходящего приведения типов. 

#### Рефакторинг реализации классов 

+ Замена объектов-значений на объекты-ссылки. 
+ Замена объектов-ссылок на объекты-значения. 
+ Замена виртуальных методов на инициализацию данных. 
+ Изменение положения методов-членов или данных-членов в иерархии наследования. 
+ Перемещение специализированного кода в подкласс. 
+ Объединение похожего кода и его перемещение в суперкласс. 

#### Рефакторинг интерфейсов классов 

+ Перемещение метода в другой класс. 
+ Разделение одного класса на несколько. 
+ Удаление класса. 
+ Сокрытие делегата. 
+ Удаление посредника. 
+ Замена наследования на делегирование. 
+ Замена делегирования на наследование. 
+ Создание внешнего метода. 
+ Создание класса-расширения. 
+ Инкапсуляция открытой переменной-члена. 
+ Удаление методов установки значений неизменяемых полей. 
+ Сокрытие методов, которые не следует вызывать извне класса. 
+ Инкапсуляция неиспользуемых методов. 
+ Объединение суперкласса и подкласса, имеющих очень похожую реализацию. 

#### Рефакторинг на уровне системы 

+ Создание эталонного источника данных, которые вы не можете контролировать. 
+ Изменение однонаправленной связи между классами на двунаправленную. 
+ Изменение двунаправленной связи между классами на однонаправленную. 
+ Предоставление фабричного метода вместо простого конструктора. 
+ Замена кодов ошибок на исключения или наоборот. 