25. Стратегии оптимизации кода
==============

### Контрольный список 

#### Производительность программы в общем 

+ Рассмотрели ли вы возможность повышения производительности посредством изменения требований к программе? 
+ Рассмотрели ли вы возможность повышения производительности путем изменения проекта программы? 
+ Рассмотрели ли вы возможность повышения производительности путем изменения проектов классов? 
+ Рассмотрели ли вы возможность повышения производительности путем сокращения объема взаимодействия с ОС? 
+ Рассмотрели ли вы возможность повышения производительности путем устранения операций ввода/вывода? 
+ Рассмотрели ли вы возможность повышения производительности путем использования компилируемого языка вместо интерпретируемого? 
+ Рассмотрели ли вы возможность повышения производительности путем видов оптимизации, поддерживаемых компилятором? 
+ Рассмотрели ли вы возможность повышения производительности путем перехода на другое оборудование? 
+ Рассматриваете ли вы оптимизацию кода только как последнее средство? 

#### Подход к оптимизации кода 

+ Убедились ли вы в полной корректности программы перед началом оптимизации кода? 
+ Нашли ли вы узкие места в коде перед началом его оптимизации? 
+ Оцениваете ли вы результаты выполнения каждого вида оптимизации кода? 
+ Отменяете ли вы изменения, которые не привели к ожидаемому улучшению? 
+ Пробуете ли вы несколько способов оптимизации каждого узкого места, т. е. используете ли вы итерацию? 

### Ключевые моменты 

+ Производительность — всего лишь один из аспектов общего качества ПО, и, как правило, не самый важный. Оптимизация кода — лишь один из способов повышения производительности ПО, и тоже обычно не самый важный. Быстродействие программы и ее объем обычно в большей степени зависят не от эффективности кода, а от архитектуры программы, детального проектирования выбора структур данных и алгоритмов. 
+ Важнейшее условие максимизации быстродействия кода — его количественная оценка. Она необходима для обнаружения областей, производительность которых действительно нуждается в повышении, а также для проверки того, что в результате оптимизации производительность повысилась, а не понизилась. 
+ Как правило, основная часть времени выполнения программы приходится на небольшую часть кода. Не выполнив оценку, вы не найдете этот код. 
+ Достижение желаемого повышения производительности кода при помощи его оптимизации обычно требует нескольких итераций. 
+ Во время первоначального кодирования нет лучше способа подготовки к повышению производительности программы, чем написание ясного и понятного кода, поддающегося легкому изменению. 
