26. Методики оптимизации кода
==============

### Контрольный список

#### Улучшение и быстродействия, и объема 

+ Замените сложную логику на обращения к таблице. 
+ Объедините циклы. 
+ Используйте целочисленные переменные вместо переменных с плавающей запятой. 
+ Инициализируйте данные во время компиляции. 
+ Используйте константы корректного типа. 
+ Вычислите результаты предварительно. 
+ Устраните часто используемые подвыражения. 
+ Перепишите ключевые методы на низкоуровневом языке. 

#### Улучшение только быстродействия 

+ Прекращайте проверку сразу же после получения ответа. 
+ Упорядочивайте тесты в блоках case и цепочках операторов if-then-else по частоте. 
+ Сравните быстродействие похожих структур логики. 
+ Используйте методику отложенных вычислений. 
+ Разомкните цикл, содержащий оператор if. 
+ Выполните развертывание цикла. 
+ Минимизируйте объем работы, выполняемой внутри цикла. 
+ Используйте сигнальные значения в циклах поиска. 
+ Вложите более ресурсоемкий цикл в менее ресурсоемкий. 
+ Снизьте стоимость операций, выполняемых внутри цикла. 
+ Замените многомерные массивы на одномерные. 
+ Минимизируйте число обращений к массивам. 
+ Дополните типы данных индексами. 
+ Кэшируйте часто используемые значения. 
+ Проанализируйте алгебраические тождества. 
+ Снизьте стоимость логических и математических выражений. 
+ Остерегайтесь системных методов. 
+ Встройте методы. 