4. Основные методики
==============

### Контрольный список

#### Кодирование 

+ Решили ли вы, какая часть проекта приложения будет разработана предварительно, а какая во время написания кода? 
+ Выбрали ли вы конвенции именования программных элементов, оформления комментариев и форматирования кода? 
+ Выбрали ли вы специфические методики кодирования, определяемые архитектурой приложения? Определили ли вы, как будут обрабатываться ошибки, как будут решаться проблемы, связанные с безопасностью, какие конвенции будут использоваться при разработке интерфейсов классов, каким стандартам должен будет отвечать повторно используемый код, сколько внимания нужно будет уделять быстродействию приложения при кодировании и т. д.? 
+ Определили ли вы стадию развития используемой технологии и адаптировали ли к ней свой подход? Если это необходимо, определились ли вы с тем, как будете программировать с использованием языка, вместо того чтобы ограничиваться программированием на нем? 

#### Работа в группе 

+ Определили ли вы процедуру интеграции? Иначе говоря, какие специфические действия программист должен будет выполнить перед включением своего кода в исходный код всего проекта? 
+ Будут ли программисты программировать парами, индивидуально или эти подходы будут скомбинированы? 

#### Гарантия качества 

+ Должны ли будут программисты разработать тесты для качества рассматривается в гласвоего кода до написания самого кода? ве 20. 
+ Должны ли будут программисты разработать блочные тесты для своего кода? 
+ Должны ли будут программисты перед включением своего кода в исходный код всего проекта проанализировать его в отладчике? 
+ Должны ли будут программисты выполнить интеграционное тестирование своего кода до его включения в исходный код проекта? 
+ Будут ли программисты выполнять взаимные обзоры или инспекцию кода? 

#### Инструменты 

+ Выбрали ли вы инструмент управления версиями? 
+ Выбрали ли вы язык, версию языка и версию компилятора? 
+ Выбрали ли вы платформу программирования (такую как J2EE или Microsoft .NET) или явно решили не использовать ее? 
+ Приняли ли вы решение о том, можно ли будет использовать нестандартные возможности языка? 
+ Определили ли вы другие средства, которые будете применять: редактор, инструмент рефакторинга, платформу для тестирования, модуль проверки синтаксиса и т. д.? Приобрели ли вы их? 

### Ключевые моменты

+ Каждый  язык  программирования  имеет  достоинства  и  недостатки.  Вы  должны  знать  отдельные  достоинства  и  недостатки  используемого  языка.
+ Определите  конвенции  программирования  до  начала  программирования. Позднее  адаптировать  к  ним  код  станет  почти  невозможно.
+ Методик  конструирования  слишком  много,  чтобы  использовать  все  в  одном проекте. Тщательно выбирайте методики, наиболее подходящие для вашего проекта.
+ Спросите  себя,  являются  ли  используемые  вами  методики  программирования ответом  на  выбранный  язык  программирования  или  их  выбор  был  определен языком.  Помните,  что  программировать  следует  с  использованием  языка,  а  не на  языке.
+ Эффективность  конкретных  подходов  и  даже  возможность  их  применения  зависит  от  стадии  развития  соответствующей  технологии.  Определите  стадию  развития используемой  технологии  и  адаптируйте  к  ней  свои  планы  и  ожидания