5. Проектирование при конструировании
==============

### Контрольный список

#### Методики проектирования 

+ Выполнили ли вы несколько итераций проектирования, выбрав самую лучшую попытку, а не просто первую? 
+ Попробовали ли вы выполнить декомпозицию системы несколькими способами с целью нахождения наилучшего варианта? 
+ Использовали ли вы для решения проблемы и нисходящий, и восходящий способы проектирования? 
+ Выполнили ли вы прототипирование сомнительных или плохо известных частей системы, создав абсолютный минимум подлежащего выбрасыванию кода, нужного для ответа на отдельные вопросы? 
+ Был ли выполнен формальный или неформальный обзор вашего проекта другими разработчиками? 
+ Довели ли вы проектирование до той точки, в которой реализация проекта кажется очевидной? 
+ Выполнили ли вы регистрацию проекта уместными способами, такими как Wiki, электронная почта, плакаты, цифровые фотографии, UML, карточки CRC или комментарии в самом коде? 

#### Цели проектирования 

+ Адекватно ли проект решает проблемы, которые были определены и отложены на этапе разработки архитектуры? 
+ Разделен ли проект на уровни? 
+ Удовлетворены ли вы тем, как выполнена декомпозиция программы на подсистемы, пакеты и классы? 
+ Удовлетворены ли вы тем, как выполнена декомпозиция классов на методы? 
+ Достигнуто ли минимальное взаимодействие классов между собой? 
+ Спроектированы ли классы и подсистемы так, чтобы их можно было использовать в других системах? 
+ Будет ли программа легкой в сопровождении? 
+ Является ли проект полным, но минимальным? Все ли его части действительно необходимы? 
+ Подразумевает ли проект использование только стандартных методик? Смогли ли вы избежать применения экзотических, трудных для понимания элементов? 
+ Помогает ли проект в целом минимизировать и несущественную, и существенную сложность? 

### Ключевые моменты

+ Главным Техническим Императивом Разработки ПО является управление сложностью. Управлять сложностью будет гораздо легче, если при проектировании вы  будете  стремиться  к  простоте.
+ Есть два общих способа достижения простоты: минимизация объема существенной сложности, с которой приходится иметь дело в любой конкретный момент времени,  и  подавление  необязательного  роста  несущественной  сложности.
+ Проектирование  —  эвристический  процесс.  Слепое  следование  какой либо  единственной  методологии  подавляет  творческое  мышление  и  снижает  качество  ваших  программ.
+ Оптимальный процесс проектирования итеративен; чем больше вариантов проектирования  вы  попробуете,  тем  удачнее  будет  ваш  окончательный  проект.
+ Одной  из  самых  полезных  концепций  проектирования  является  сокрытие  информации.  Вопрос  «Что  мне  скрыть?»  устраняет  много  сложных  проблем  проектирования.
+ Много  полезной  и  интересной  информации  о  проектировании  можно  найти  в  других  книгах.  Описанные  в  этой  главе  идеи  —  лишь  вершина  айсберга.