9. Процесс Программирования с Псевдокодом
==============

### Контрольный список

+ Проверили  ли  вы,  что  удовлетворяются  предварительные  условия?
+ Определена  ли  проблема,  которую  решает  класс?
+ Достаточно  ли  понятна  высокоуровневая  конструкция, чтобы  дать  классам  и  методам  адекватные  имена?
+ Продумали ли вы тестирование класса и каждого из его методов?
+ Рассматривали ли вы эффективность с позиции стабильных интерфейсов и понятной реализации или с позиции соответствия ресурсам и бюджету? 
+ Проанализировали ли вы стандартные и другие библиотеки на предмет наличия подходящих методов и компонентов? 
+ Просмотрели ли вы литературу в поисках полезных алгоритмов? 
+ Проектировали ли вы каждый метод с использованием подробного псевдокода? 
+ Проверили ли вы псевдокод умозрительно? Легко ли его понять? 
+ Уделили ли вы внимание предупреждениям, которые указывают на необходимость перепроектирования (использование глобальных данных, операции, которые лучше перенести в другой класс или метод и т. д.)? 
+ Точно ли вы перевели псевдокод в код? 
+ Рекурсивно ли вы применяли ППП, разбивая методы на более мелкие при необходимости? 
+ Документировали ли вы принимаемые допущения? 
+ Убрали ли вы избыточные комментарии? 
+ Проделали ли вы несколько итераций или остановились после первой? 
+ Вполне ли вы понимаете свой код? Легко ли в нем разобраться? 

### Ключевые моменты 

+ Конструирование классов и методов — процесс итеративный. Особенности, замечаемые при конструировании отдельных методов, заставляют возвращаться к проектированию класса. 
+ Написание хорошего псевдокода предполагает употребление понятного естественного языка без специфических особенностей конкретного языка программирования, а также формулировок на уровне намерений (описания сути конструкции, а не способов ее работы). 
+ Процесс  Программирования  с  Псевдокодом  —  полезный  инструмент  детального  проектирования,  упрощающий  кодирование.  Псевдокод  транслируется непосредственно  в  комментарии,  гарантируя  их  адекватность  и  полезность.
+ Не  останавливайтесь  на  первой  придуманной  вами  конструкции  —  испробуйте  несколько  подходов  и  выберите  лучший,  прежде  чем  писать  код.
+ Проверяйте  свою  работу  на  каждом  шаге  и  просите  об  этом  других.  При  этом вы  отловите  ошибки  на  наименее  дорогостоящем  уровне,  когда  вы  вложили  в работу  меньше  усилий.